--[[
1920 x 1080		screen  
256 x 128  		player ship
64 x 64 		kleiner gegner
128 x 128 		mittlerer gegner
256 x 256 		grosser gegner

stylenotes:
godzilla-schmelzender panzer : 1:25 http://www.youtube.com/watch?v=RFDNj1nJdP8
raumpatroullie orion - planet flyby : 0:10 http://www.youtube.com/watch?v=ZR8aSPT81pA
funken sprh : captain proton : http://drexfiles.wordpress.com/2009/07/08/captain-proton/
startrek planet background 03:27 http://www.youtube.com/watch?v=kl4XAevNd-c&feature=related
startrek phaser sound 13:24 http://www.youtube.com/watch?v=kl4XAevNd-c&feature=related
star trek

(robert lokal screen = 1440 x 900)

note : midi convert   pd extended, das ding mit nur 2 kstchen oeffnen, unteres kaestchen : 
[18:47:22] Filippo Beck Peccoz: read *.mid
[18:47:25] Filippo Beck Peccoz: als message
-> erzeugt  in output   einen text, den in midi.txt kopieren, dann in vanilla oeffnen

Lautstaerke Receiver (0-0.2 !!!!!) ;D
	vol_main
	vol_layer1	
	vol_layer2
	vol_layer3
	vol_layer4
	vol_layer5
	

Filter Receiver
	filter (70-127)
	
	instrument : theremin  das ufo ding

	back01.jpg : 0x14,0x13,0x14

musik : stefan, filippo nach skype fragen

	
]]--

love.filesystem.load("lib.oop.lua")()

local max		= math.max
local min		= math.min
local abs		= math.abs
local random	= math.random
local floor		= math.floor
local ceil		= math.ceil
local sin		= math.sin
local cos		= math.cos

DEG_2_RAD = 2*math.pi/180 
		
gPlayers = {}
gShots = {}
gEnemies = {}
gEffects = {}
gPowerUps = {}

WORLD_SCROLL_SPEED = 200 -- pixels/Sec
BACK_IMG_W = 1024*2
BACK_IMG_H = 1024
gWorldX = 0 -- img_back01

gMenuActive = true
gKeyPressed = {}

gPlayerScore = 0
gPlayerScoreMax = 0

gNextEnemyT = 0
gNextPlayerShot = 0
PLAYER_SHOT_INTERVAL = 0.4  -- / 100
PLAYER_SHOT_SPEED = 1200 -- pixel/sec
ENEMY_SHOT_SPEED = 600 -- pixel/sec

PLAYER_START_HP = 100

ENEMY_SHOT_INTERVAL = 2.0 -- / 100
EXPLOSION_TIME_OF_LIFE = 0.2

POWERUP_VX = -200

ENEMY_VY_MAX = 100
ENEMY_VY_CYCLE_T = 3.0

COLLISION_DAMAGE = 5

SCORE_HP_FACTOR = 1000

ENABLE_PD = true

cObj = CreateClass()
cShip = CreateClass(cObj)
cPowerUp = CreateClass(cObj)
cPlayer = CreateClass(cShip)
cEnemy = CreateClass(cShip)
cShot = CreateClass(cObj)
cEffect = CreateClass(cObj)
	
gNextMusicChange = 0
MUSIC_CHANGE_INTERVAL = 10

SHIELD_FAIL_WAIT 		= 0.5 -- seconds
SHIELD_ENERGY_MAX		= 3
SHIELD_ENERGY_DRAIN		= 1 -- per second
SHIELD_ENERGY_RECHARGE	= 0.5 -- per second


-- ***** ***** ***** ***** ***** load

function love.load ()
	gMyTime = love.timer.getTime()
	
	MyPD_Init()
	
	local function myimg (path) return love.graphics.newImage(path) end
	
	--~ img_back01		= myimg("data/back01.jpg")
	img_back01		= myimg("data/back02.jpg")
	img_splash		= myimg("data/rocket_splash.png")
	
	img_expl_left	= myimg("data/expl-left.png")
	img_expl_right	= myimg("data/expl-right.png")
	
	EXPL_RIGHT_OX,EXPL_RIGHT_OY = -56,-37
	EXPL_LEFT_OX,EXPL_LEFT_OY = -200,-37
	
	local e = 32
	img_enemy01		= {
		up		= {img=myimg("data/enemy1_up.png")		,sx=11,sy=30	},
		normal	= {img=myimg("data/enemy1_normal.png")	,sx=10,sy=32	},
		down	= {img=myimg("data/enemy1_down.png")	,sx=10,sy=33		},
		ox = -e,
		oy = -e,
		r = e*0.8,
	}
	
	local e = 64/2
	img_enemy02		= {
		up		= {img=myimg("data/enemy2_up.png")		,sx=21/2,sy=21/2	},
		normal	= {img=myimg("data/enemy2_normal.png")	,sx=15/2,sy=28/2	},
		down	= {img=myimg("data/enemy2_down.png")	,sx= 8/2,sy=39/2	},
		ox = -128/2,
		oy = -64/2,
		r = e*0.8,
	}
	
	

	local e = 128 -- 128x256  high
	img_enemy03		= {
		up		= {img=myimg("data/enemy3_up.png")		,sx=36,sy=29	,sx2= 7 ,sy2=222		},
		normal	= {img=myimg("data/enemy3_normal.png")	,sx=19,sy=28	,sx2=19 ,sy2=226		},
		down	= {img=myimg("data/enemy3_down.png")	,sx=7,sy=32		,sx2=29 ,sy2=218		},
		ox =  -64,
		oy = -128,
		r = e*0.8,
		dualshot = true,
	}
	
	anim_asteroid = {
		myimg("data/asteroid_a0000.png"),
		myimg("data/asteroid_a0001.png"),
		myimg("data/asteroid_a0002.png"),
		myimg("data/asteroid_a0003.png"),
		myimg("data/asteroid_a0004.png"),
		myimg("data/asteroid_a0005.png"),
		myimg("data/asteroid_a0006.png"),
		myimg("data/asteroid_a0007.png"),
		myimg("data/asteroid_a0008.png"),
		myimg("data/asteroid_a0009.png"),
		dur = 1,
		ox = -64,
		oy = -64,
		r = 64,
	}
	
	anim_powerup = {
		myimg("data/powerup_a0000.png"),
		myimg("data/powerup_a0001.png"),
		myimg("data/powerup_a0002.png"),
		myimg("data/powerup_a0003.png"),
		myimg("data/powerup_a0004.png"),
		myimg("data/powerup_a0005.png"),
		myimg("data/powerup_a0006.png"),
		myimg("data/powerup_a0007.png"),
		myimg("data/powerup_a0008.png"),
		myimg("data/powerup_a0009.png"),
		dur = 1,
		ox = -64,
		oy = -64,
		r = 64,
	}
	
	local e = 64
	img_enemy04		= {
		up		= {img=myimg("data/asteroid00.png")	,sx=e,sy=e},
		normal	= {img=myimg("data/asteroid00.png")	,sx=e,sy=e},
		down	= {img=myimg("data/asteroid00.png")	,sx=e,sy=e},
		ox = -e,
		oy = -e,
		r = e*0.8,
	}
	
	
	local e = 64
	img_enemy05		= {
		up		= {img=myimg("data/asteroid01.png")	,sx=e,sy=e},
		normal	= {img=myimg("data/asteroid01.png")	,sx=e,sy=e},
		down	= {img=myimg("data/asteroid01.png")	,sx=e,sy=e},
		ox = -e,
		oy = -e,
		r = e*0.8,
	}
	
	img_player		= {
		up		= {img=myimg("data/player_up.png")		,sx=223,sy=74},
		normal	= {img=myimg("data/player_normal.png")	,sx=220,sy=84},
		down	= {img=myimg("data/player_down.png")	,sx=216,sy=90},
		ox = -128,
		oy = -64,
		r = 64*0.8,
	}
	-- img_playerU img_player img_playerD 
	
	
	img_expl_shield	= myimg("data/expl-shield.png")	
	img_shield		= myimg("data/shield.png")	
	
	
	img_shot02_L	= myimg("data/shot02-L.png")
	img_shot01_L	= myimg("data/shot01-L.png")
	img_shot01		= myimg("data/shot01.png")			

	local function mysnd(path) return {snd=love.audio.newSource( path, "static" ),path=path} end
	mysounds = {
		--~ mysnd("sound-samples/3_12.wav"),
		--~ mysnd("sound-samples/ANNIGUN1.wav"),
		--~ mysnd("sound-samples/ATST-ChinGuns.wav"),
		--~ mysnd("sound-samples/ISD-Laser2.wav"),
		--~ mysnd("sound-samples/shot01.wav"),
		--~ mysnd("sound-samples/shot02.wav"),
		--~ mysnd("sound-samples/sound9.mp3"),
	}
	function MySoundKey(key) 
		local o = mysounds[tonumber(key) or 0]
		if (o) then print("MySoundKey",key,o.path) o.snd:rewind() o.snd:play() end
	end

	
	PlayerRespawn()
	
	local g = 32
	--~ love.graphics.setBackgroundColor( g, g, g )
	love.graphics.setBackgroundColor( 0x14,0x13,0x14 )
	
	
	love.graphics.setFont(love.graphics.newFont(40))
end


function PlayerRespawn ()
	gPlayerScore = 0
	gPlayer = cPlayer:New({
		 imgarr = img_player
		,img_shield = img_shield
		,x = 0
		,y = 0
		,ox = img_player.ox
		,oy = img_player.oy
		,r = img_player.r 
		,hp = PLAYER_START_HP
		,isPlayer = true
	})
	gPlayers = {}
	gPlayers[gPlayer] = true
end

-- ***** ***** ***** ***** ***** pd

function libpdhook (event,...) print("libpdhook",event,...) end

function MyPD_Init () 
	--~ local filepath,dir = "shooter.pd","audio"
	--~ local filepath,dir = "shooter_v2.pd","audio"
	local filepath,dir = "shooter_v3.pd","audio"
	local delay = 100
	
	if (ENABLE_PD) then 
		print("init pd 01")
		require("lovepdaudio") 
		print("init pd 02")
	else 
		print("init pd dummy")
		-- make dummy
		lovepdaudio = {}
		lovepdaudio.CreatePureDataPlayer = function () return {} end
		lovepdaudio.PureDataPlayer_Update = function () end
		libpd_add_to_search_path = function () end
		libpd_float = function () end
		--~ libpd_float = function (receiver_name,val) PDNet:SendFloat(receiver_name,val) end
		libpd_bang = function () end
		libpd_bind = function () end
	end
	
	gPDPlayer = lovepdaudio.CreatePureDataPlayer(filepath,dir,delay)
	print("init pd 03")
	
	libpd_bind("mynote")
	
	if (filepath == "shooter_v3.pd") then libpd_float("speed",0.0125) libpd_bang("mynoteinit") end
	--~ if (filepath == "shooter_v2.pd") then libpd_float("speed",0.0125) end
	--~ if (filepath == "shooter_v2.pd") then libpd_bang("myplay") end
end

function MyPD_Step (dt,t) 
	lovepdaudio.PureDataPlayer_Update(gPDPlayer)
	
	for valname,o in pairs(gPDValues) do 
		local vnew = o.vcur
		local dv = abs(dt * (o.vmax - o.vmin) / o.fadet)
		if (not vnew) then 
			vnew = o.vrequested
		elseif (o.vrequested >= vnew) then 
			vnew = min(o.vrequested,vnew + dv)
		elseif (o.vrequested <= vnew) then 
			vnew = max(o.vrequested,vnew - dv)
		end
		new = max(o.vmin,min(o.vmax,vnew))
		if (o.vcur ~= vnew) then
			o.vcur = vnew
			--~ print("MyPD_Step set",valname,vnew)
			libpd_float(valname,vnew)
		end
	end
end

gPDValues = {}
local maxvol_layer = 0.2
gPDValues.filter		= {vmax=127,vmin=70,fadet=0.3}
gPDValues.vol_main		= {vmax=maxvol_layer,vmin=0,fadet=0.5}
gPDValues.vol_layer1	= {vmax=maxvol_layer,vmin=0,fadet=0.5}
gPDValues.vol_layer2	= {vmax=maxvol_layer,vmin=0,fadet=0.5}
gPDValues.vol_layer3	= {vmax=maxvol_layer,vmin=0,fadet=0.5}
gPDValues.vol_layer4	= {vmax=maxvol_layer,vmin=0,fadet=0.5}
gPDValues.vol_layer5	= {vmax=maxvol_layer,vmin=0,fadet=0.5}

for k,o in pairs(gPDValues) do 
	o.vcur			= nil -- o.vmax 
	o.vrequested	= o.vmax 
end

-- factor : 0-1
function RequestAudio (name,factor) 
	local o = gPDValues[name]
	o.vrequested = o.vmin + max(0,min(1,factor)) * (o.vmax-o.vmin)
end


function MyPD_OnKey (key) 
	function MyDebugRequestAudio (name,v) print("MyDebugRequestAudio",name,v) RequestAudio(name,v) end
	if (key == "q") then MyDebugRequestAudio("vol_main",1.0) end
	if (key == "a") then MyDebugRequestAudio("vol_main",0.5) end
	if (key == "y") then MyDebugRequestAudio("vol_main",0.0) end
	
	if (key == "w") then MyDebugRequestAudio("vol_layer1",1.0) end
	if (key == "s") then MyDebugRequestAudio("vol_layer1",0.5) end
	if (key == "x") then MyDebugRequestAudio("vol_layer1",0.0) end
	
	if (key == "e") then MyDebugRequestAudio("vol_layer2",1.0) end
	if (key == "d") then MyDebugRequestAudio("vol_layer2",0.5) end
	if (key == "c") then MyDebugRequestAudio("vol_layer2",0.0) end
	
	if (key == "r") then MyDebugRequestAudio("vol_layer3",1.0) end
	if (key == "f") then MyDebugRequestAudio("vol_layer3",0.5) end
	if (key == "v") then MyDebugRequestAudio("vol_layer3",0.0) end
	
	if (key == "t") then MyDebugRequestAudio("vol_layer4",1.0) end
	if (key == "g") then MyDebugRequestAudio("vol_layer4",0.5) end
	if (key == "b") then MyDebugRequestAudio("vol_layer4",0.0) end
	
	if (key == "z") then MyDebugRequestAudio("vol_layer5",1.0) end
	if (key == "h") then MyDebugRequestAudio("vol_layer5",0.5) end
	if (key == "n") then MyDebugRequestAudio("vol_layer5",0.0) end
	
	if (key == "k") then MusicNewRandom() end
	
	
	if (key == "1") then libpd_bang("explosion") end
	if (key == "2") then libpd_bang("shot") end
	if (key == "3") then libpd_bang("powerup") end
end

function MusicNewRandom ()
	local a = (randf() < 0.5) and 1 or 0
	local b = (randf() < 0.5) and 1 or 0
	local c = (randf() < 0.5) and 1 or 0
	local d = (randf() < 0.5) and 1 or 0
	local e = (randf() < 0.5) and 1 or 0
	RequestAudio("vol_layer1", a)
	RequestAudio("vol_layer2", b)
	RequestAudio("vol_layer3", c)
	RequestAudio("vol_layer4", d)
	RequestAudio("vol_layer5", e)
	gRandomMixTxt = a..","..b..","..c..","..d..","..e
	print("random mix",a,b,c,d,e)
end



-- ***** ***** ***** ***** ***** cObj

function cObj:Init(t) 
	for k,v in pairs(t) do self[k] = v end
	self.startt = gMyTime
end

function cObj:DistTo(o)
	local dx = self.x - o.x
	local dy = self.y - o.y
	return math.sqrt(dx*dx + dy*dy)
end

function cObj:Draw()
	local o = self
	if (o.img) then love.graphics.draw(o.img,o.x+(o.ox or 0),o.y+(o.oy or 0)) end
	if (self.bShield) then love.graphics.draw(o.img_shield,o.x+o.ox,o.y+o.oy) end
end

function cObj:SetAnimFrame (t,anim) 
	local numframes = #anim
	local framei = math.mod(floor(numframes * (t+self.startt) / anim.dur),numframes) + 1
	self.img = anim[framei] or anim[1]
	self.ox = anim.ox
	self.oy = anim.oy
	self.r = anim.r
	--~ print("SetAnimFrame","numframes",numframes,"framei",framei)
end

-- ***** ***** ***** ***** ***** cPlayer

function cPlayer:Destroy() gPlayers[self] = nil gPlayer = nil end

function cPlayer:Init (...) 
	cObj.Init(self,...)
	self.power = 0
	self.maxpower = 8
	self.next_shot_i = 0
	self.shield_energy = SHIELD_ENERGY_MAX
	self.next_shield_t = 0
end

function cPlayer:OnDamage	(shot)
	if (shot and shot.bSmallShot and randf() < 0.5) then return end -- small enemy shot has 50% chance not to reduce power
	self.power = max(0,self.power - 1)
end 

function cPlayer:CollectPowerUp()
	self.power = min(self.maxpower,self.power + 1)
end 



function cPlayer:Step(dt,t,vw,vh)
	local mx = love.mouse.getX()
	local my = love.mouse.getY()
	
	local bWantShield = gKeyPressed["mr"]
	local bShieldActive = bWantShield and gMyTime > self.next_shield_t
	
	if (bShieldActive) then 
		self.shield_energy = max(0,self.shield_energy - dt*SHIELD_ENERGY_DRAIN)
		if (self.shield_energy <= 0) then self.next_shield_t = gMyTime + SHIELD_FAIL_WAIT end
	else 
		self.shield_energy = min(SHIELD_ENERGY_MAX,self.shield_energy + dt*SHIELD_ENERGY_RECHARGE)
	end
	
	
	self.bShield = bShieldActive
	
	
	
	RequestAudio("filter", self.bShield and 0 or 1)
	
	local newx = mx
	local newy = my
	newx = 200
	
	local b = 20
		if (newy < self.y - b) then self.imgdir = "up"
	elseif (newy > self.y + b) then self.imgdir = "down"
	else 							self.imgdir = "normal" end

	local f = 0.98
	local fi = 1-f
	gPlayer.x = f*gPlayer.x + fi*newx
	gPlayer.y = f*gPlayer.y + fi*newy
	
	if (gKeyPressed["t"]) then self.imgdir = "up" end
	if (gKeyPressed["g"]) then self.imgdir = "normal" end
	if (gKeyPressed["b"]) then self.imgdir = "down" end
	
	local imgdata = self.imgarr[self.imgdir]
	self.img = imgdata.img
	
	
	-- spawn player shot
	if (love.mouse.isDown("l") and gNextPlayerShot < gMyTime) then 
		
		local pow = self.power
		gNextPlayerShot = gMyTime + PLAYER_SHOT_INTERVAL
		
		local aox= -1*gPlayer.ox
		local aoy= -1*gPlayer.oy
		
		local sx = imgdata.sx
		local sy = imgdata.sy
		
		local a = gPlayer
		local ox=-8
		local oy=-8
		
		libpd_bang("shot")
		
		for shoti=0,pow do 
			
			--~ local ang = min(45,2 * self.power)*DEG_2_RAD * rand_in_range(-1,1)
			--~ local shoti = math.mod(self.next_shot_i,pow)
			local angh = min(10,2 * pow) * DEG_2_RAD
			local ang = (pow > 0) and (angh - 2*angh*shoti/pow) or 0
			local v = PLAYER_SHOT_SPEED
			local vx = v*cos(ang) 
			local vy = v*sin(ang) 
			
			
			local o = cShot:New({ x=a.x + sx - aox,y=a.y + sy - aoy, img=img_shot01, ox=ox,oy=oy, vx=vx,vy=vy, bPlayerShot=true})
			gShots[o] = true
			
			--~ self.next_shot_i = self.next_shot_i + 1
		end
	end
end

-- ***** ***** ***** ***** ***** cEnemy


function cEnemy:Destroy() gEnemies[self] = nil end

function cEnemy:Step(dt,t,vw,vh)
	if (self.x < -self.r) then return self:Destroy() end
	local o = self
	o.x = o.x + o.vx * dt
	o.y = o.y + o.vy * dt
	
	if (not self.isAsteroid) then 
	o.vy = ENEMY_VY_MAX * math.sin((t+o.startt) / ENEMY_VY_CYCLE_T * math.pi * 2)
	end
	
		if (self.vy < -0.2 * ENEMY_VY_MAX) then self.imgdir = "up"
	elseif (self.vy >  0.2 * ENEMY_VY_MAX) then self.imgdir = "down"
	else 										self.imgdir = "normal" end
	
	local imgdata = self.imgarr[self.imgdir]
	self.img = imgdata.img
	
	if (self.isAsteroid) then self:SetAnimFrame(t,anim_asteroid) end
	
	--~ o.vy = 0 -- HACK
	
	-- collisioncheck
	if (gPlayer) then 
		local a = self 
		local b = gPlayer
		if (a:DistTo(b) < a.r + b.r) then
			a:Damage(b,COLLISION_DAMAGE)
			b:Damage(a,COLLISION_DAMAGE)
		end
	end
	
	if (not self.isAsteroid) then 
	if (o.nextshot < t) then 
		o.nextshot = t + ENEMY_SHOT_INTERVAL
		local a = o
		
		local aox= -1*o.ox
		local aoy= -1*o.oy
		
		
		local numshots = self.imgarr.dualshot and 2 or 1
		
		for ishot = 1,numshots do 
			local sx = (ishot == 1) and imgdata.sx or imgdata.sx2
			local sy = (ishot == 1) and imgdata.sy or imgdata.sy2
			
			local o
			if (self.smallshots) then 
				o = cShot:New({ x=a.x + sx - aox,y=a.y + sy - aoy, img=img_shot02_L, ox=-8,oy=-8, vx=-ENEMY_SHOT_SPEED,bSmallShot=true,vy=0})
			else 
				o = cShot:New({ x=a.x + sx - aox,y=a.y + sy - aoy, img=img_shot01_L, ox=-16,oy=-16, vx=-ENEMY_SHOT_SPEED,vy=0})
			end
			gShots[o] = true
		end
	end
	end
end

-- ***** ***** ***** ***** ***** cShip
 
function SpawnExpl (x,y,bLeft,bShield,durfactor) 
		
	local img,ox,oy = img_expl_shield,-32,-32
	if (not bShield) then
		if (bLeft) then 
			img,ox,oy = img_expl_left,EXPL_LEFT_OX,EXPL_LEFT_OY
		else
			img,ox,oy = img_expl_right,EXPL_RIGHT_OX,EXPL_RIGHT_OY
		end
	end
	
	local e = cEffect:New({x=x,y=y,endt=gMyTime+(durfactor or 1) * EXPLOSION_TIME_OF_LIFE,ox=ox,oy=oy,img=img})
	gEffects[e] = true
end

function cShip:Damage (shot,dmg)
	
	local x,y = self.x,self.y
	if (shot) then x,y = shot.x,shot.y end
	
	local dy = abs(y - self.y)
	local fy = max(0,min(1,dy/self.r))
	local var_x = self.r * (1 - fy)
	x = self.x + var_x * rand_in_range(-1,1)
	if (not self.isPlayer) then 
		--~ print("expl","dy="..dy,"fy="..fy,"var_x="..var_x,"r="..self.r)
		--~ expl    dy=94.433612649127      fy=0.92220324852663     var_x=7.9663873508727   r=102.4
		--~ expl    dy=52.206030189173      fy=0.50982451356614     var_x=50.193969810827   r=102.4
		--~ expl    dy=35.392535689028      fy=0.34563023133817     var_x=67.007464310972   r=102.4
		--~ expl    dy=13.149293393898      fy=0.12841106829978     var_x=89.250706606102   r=102.4
	end
	
	SpawnExpl(x,y,self.isPlayer,self.bShield)
	
	if (not self.bShield) then 
		if (self.OnDamage) then self:OnDamage(shot) end
		self.hp = self.hp - (dmg or 1)
		if (self.hp <= 0) then
			libpd_bang("explosion")		
			for i=1,5 do 
				local x = self.x + self.r * rand_in_range(-1,1)
				local y = self.y + self.r * rand_in_range(-1,1)
				SpawnExpl(x,y,x < self.x,false,1+0.2*rand_in_range(-1,1))
			end
			if (randf() < 0.5) then SpawnPowerUp(self.x,self.y) end
			
			if (not self.isPlayer) then PlayerGetScore(self.score) end 
			
			return self:Destroy()
		end
	end
end

function PlayerGetScore (score) 
	gPlayerScore = gPlayerScore + score
	gPlayerScoreMax = max(gPlayerScoreMax,gPlayerScore)
end

-- ***** ***** ***** ***** ***** cShot

function cShot:Destroy() gShots[self] = nil end

function cShot:Step(dt,t,vw,vh)
	local o = self
	if ((o.vx > 0 and o.x >= vw) or 
		(o.vx < 0 and o.x <= 0)) then 
		return self:Destroy()
	end
	
	local targetlist
	if (self.bPlayerShot) then 
		targetlist = gEnemies
	else
		targetlist = gPlayers
	end
	
	for a,v in pairs(targetlist) do 
		if (a:DistTo(self) < a.r) then
			a:Damage(self,self.bSmallShot and 0.5 or 1)
			return self:Destroy()
		end
	end
	
	o.x = o.x + o.vx * dt
	o.y = o.y + o.vy * dt	
end

-- ***** ***** ***** ***** ***** cPowerUp

function SpawnPowerUp (x,y)
	local o = cPowerUp:New({x=x,y=y,vx=POWERUP_VX,vy=0})
	gPowerUps[o] = true
end 

function cPowerUp:Destroy() gPowerUps[self] = nil end


function cPowerUp:Step (dt,t,vw,vh)
	local o = self
	o.x = o.x + o.vx * dt
	o.y = o.y + o.vy * dt
	self:SetAnimFrame(t,anim_powerup)
	
	-- collisioncheck
	if (gPlayer) then 
		local a = self 
		local b = gPlayer
		if (a:DistTo(b) < a.r + b.r) then
			libpd_bang("powerup")	
			gPlayer:CollectPowerUp()
			return self:Destroy()
		end
	end
	
	
	if (self.x < -self.r) then return self:Destroy() end
end
	
	
-- ***** ***** ***** ***** ***** cEffect

function cEffect:Destroy() gEffects[self] = nil end

function cEffect:Step	(dt,t,vw,vh)
	if (t >= self.endt) then return self:Destroy() end
end


-- ***** ***** ***** ***** ***** key + mouse

function love.mousereleased( x, y, button  )
	gKeyPressed["m"..button] = nil
end	

function love.mousepressed( x, y, button )
	gMenuActive = false
	gKeyPressed["m"..button] = true
	if (button == "l") then 
		if (not gPlayer) then PlayerRespawn() end
	end
end

function love.keypressed( key, unicode )
	gMenuActive = false
    if (key == "escape") then os.exit(0) end
    --~ if (key == "f12") then love.graphics.toggleFullscreen() end
    if (key == "f12") then 
		local width = 1920
		local height = 1080
		local fullscreen = true
		local vsync = false
		local fsaa = 0
		love.graphics.setMode( width, height, fullscreen, vsync, fsaa )
	end
	gKeyPressed[key] = true
	MyPD_OnKey(key)
	MySoundKey(key)
	if (not gPlayer) then PlayerRespawn() end
end
function love.keyreleased( key ) gKeyPressed[key] = nil end


-- ***** ***** ***** ***** ***** utils

function randf () return math.random() end
function rand_in_range (vmin,vmax) return vmin+(vmax-vmin)* math.random() end

function SpawnEnemy(dt,t,vw,vh)
	gNextEnemyT = gMyTime + 1.0
	local b = 100
	local x,y = vw,rand_in_range(b,vh-b)
	
	local avy = 50 * rand_in_range(-1,1)
	
	local o
	if (randf() < 0.1) then -- very big
		o = cEnemy:New({ x=x,y=y, imgarr=img_enemy03 ,vx=-50,vy=0	,hp=50 })
	elseif (randf() < 0.2) then -- medium
		o = cEnemy:New({ x=x,y=y, imgarr=img_enemy02 ,vx=-100,vy=0	,hp=10 })
	else -- normal
		if (randf() < 0.5) then 
			-- small enemy
			o = cEnemy:New({ x=x,y=y, imgarr=img_enemy01 ,vx=-200,vy=0	,hp=2, smallshots=true})
		else 
			-- isAsteroid
			if (randf() < 0.5) then 
				o = cEnemy:New({ x=x,y=y, imgarr=img_enemy04 ,vx=-400,vy=avy 	,isAsteroid=true,hp=2})
			else
				o = cEnemy:New({ x=x,y=y, imgarr=img_enemy05 ,vx=-400,vy=avy 	,isAsteroid=true,hp=2})
			end
		end
	end
	
	--~ if (next(gEnemies)) then return end 
	--~ o = cEnemy:New({ x=x,y=y, imgarr=img_enemy04 ,vx=-400,vy=avy 	,isAsteroid=true,hp=2})
	--~ o = cEnemy:New({ x=x,y=y, imgarr=img_enemy03 ,vx=-50,vy=0	,hp=50 })
				
	o.r = o.imgarr.r
	o.ox = o.imgarr.ox
	o.oy = o.imgarr.oy
	o.x = o.x + o.r
	o.nextshot = 0
	o.score = SCORE_HP_FACTOR * o.hp + 125
	gEnemies[o] = true
end
 
-- ***** ***** ***** ***** ***** update

function love.update (dt)
	dt = min(0.1,dt)
	
	gScreenW = love.graphics.getWidth( )
	gScreenH = love.graphics.getHeight( )
	gMyTime = love.timer.getTime()
	
	if (gMenuActive) then return MenuUpdate(dt) end 
	GameUpdate(dt)
end 

function GameUpdate (dt)
	if (gDoPDUpdate) then lovepdaudio.PureDataPlayer_Update(gPDPlayer) end
	local mx = love.mouse.getX()
	local my = love.mouse.getY()
	
	local vw = gScreenW
	local vh = gScreenH
	
	local t = gMyTime
	MyPD_Step(dt,t)
	
	-- spawn enemy
	if (gMyTime > gNextEnemyT) then SpawnEnemy(dt,t,vw,vh) end
	
	-- step
	for o,v in pairs(gPlayers)	do o:Step(dt,t,vw,vh) end
	for o,v in pairs(gShots)	do o:Step(dt,t,vw,vh) end
	for o,v in pairs(gEffects)	do o:Step(dt,t,vw,vh) end
	for o,v in pairs(gPowerUps)	do o:Step(dt,t,vw,vh) end
	for o,v in pairs(gEnemies)	do o:Step(dt,t,vw,vh) end
	
	gWorldX = gWorldX + dt * WORLD_SCROLL_SPEED
		
	if (gNextMusicChange < gMyTime) then 	
		gNextMusicChange = gMyTime + MUSIC_CHANGE_INTERVAL
		MusicNewRandom()
	end
end

-- ***** ***** ***** ***** ***** tausender


function TausenderTrenner (v)
	local txt = tostring(abs(v))
	local len = #txt
	local res = ""
	for i=1,len do 
		local cpos = len-i+1
		local c = string.sub(txt,cpos,cpos)
		res = c .. res
		if ((i % 3) == 0 and i < len) then res = "," .. res end
	end
	
	
	return (v<0) and ("-"..res) or res
end

-- ***** ***** ***** ***** ***** menu
gMenuAlphaT = 0

function MenuUpdate(dt)
	gMenuAlphaT = gMenuAlphaT + dt
end
function MenuDraw ()
	local vw = gScreenW or 1024
	local vh = gScreenh or 786
	local x = vw/2 - 1024/2
	local y = vh/2 - 512/2
	local alpha = min(1,gMenuAlphaT/1)*255 love.graphics.setColor( 255, 255, 255, alpha )
	love.graphics.draw(img_splash,x,y)
	local alpha = 1.0*255 love.graphics.setColor( 255, 255, 255, alpha )
end
-- ***** ***** ***** ***** ***** draw

function love.draw () 
	if (gMenuActive) then return MenuDraw() end
	GameDraw()
end 



function GameDraw () 

	-- draw background 
	
	
	local back_x = -(gWorldX - BACK_IMG_W * floor(gWorldX/BACK_IMG_W))
	local numback = 0
		--~ print("back:")
	while back_x < gScreenW do 
		--~ print(" ",back_x)
		love.graphics.draw(img_back01,floor(back_x),gScreenH-BACK_IMG_H)
		back_x = back_x + BACK_IMG_W
		numback = numback + 1
	end
	if (numback > 5) then print("warning, numback",numback) end
	
	
	local vw = gScreenW or 1024
	local vh = gScreenh or 786
	
	
	-- draw game objects
	
	love.graphics.print(gRandomMixTxt or "",10,vh - 60)
	for o,v in pairs(gPlayers)	do o:Draw() end
	for o,v in pairs(gEnemies)	do o:Draw() end
	for o,v in pairs(gShots)	do o:Draw() end
	for o,v in pairs(gEffects)	do o:Draw() end
	for o,v in pairs(gPowerUps)	do o:Draw() end
	
	
	
	-- hud 
	
	local fhp = gPlayer and (gPlayer.hp / PLAYER_START_HP) or 0
	local fsh = gPlayer and (gPlayer.shield_energy / SHIELD_ENERGY_MAX) or 0
	
	local b = 5
	local a = 3
	local x,y = vw/4 + 10,10
	local w,h = vw/2,b*2+1
	
	love.graphics.rectangle("fill" or "",x+a,y+a    ,(w-a-a)*fhp,h-a-a)
	
	local alpha = 0.7*255 love.graphics.setColor( 255, 255, 255, alpha )
	local e = 3
	
	--~ love.graphics.rectangle("line" or "",x,y    ,w,h)
	--~ love.graphics.rectangle("line" or "",x,y+h+b,w,h)
	
	love.graphics.rectangle("fill" or "",x+a-e,y+a-e   ,(w-a-a+e+e)*fsh,h-a-a+e+e)
	
	
	local k = 255
	local alpha = 1.0*255 love.graphics.setColor( k, k, k, alpha )
	
	local e = 4
	love.graphics.rectangle("line" or "",x+a-e,y+a-e   ,(w-a-a+e+e),h-a-a+e+e)
	
	local alpha = 1.0*255 love.graphics.setColor( 255, 255, 255, alpha )
	
	
	local b = 5
	love.graphics.print(TausenderTrenner(gPlayerScore),b,b)
	if (gPlayerScoreMax > gPlayerScore) then love.graphics.print(TausenderTrenner(gPlayerScoreMax),b,b+40) end
	

end


